---------------------------------------------------------------
-- Copyright Esperan Multimedia Products Limited 1995
--
-- 10 to 4 decoder to decode keys pressed in alarm clock design, 
-- forming part of the MasterClass VHDL Tutorial. 
--------------------------------------------------------------- 

library IEEE;
use IEEE.Std_Logic_1164.all;

entity DISMUX is
   port (ALARM_TIME, CURRENT_TIME   : in std_logic_vector (3 downto 0);
          SHOW_A                    : in std_logic;
          SOUND_ALARM               : out std_logic;
          DISPLAY_TIME              : out std_logic_vector (3 downto 0)
	);
end DISMUX;

architecture RTL of DISMUX is

begin

   DISMUX_process: process(ALARM_TIME, CURRENT_TIME, SHOW_A)
   begin
      if SHOW_A = '1'
        then DISPLAY_TIME <= ALARM_TIME;
        else DISPLAY_TIME <= CURRENT_TIME;
      end if;
      if ALARM_TIME = CURRENT_TIME
        then SOUND_ALARM <= '1';
        else SOUND_ALARM <= '0';
      end if;
   end process DISMUX_process;

end RTL;

