---------------------------------------------------------------
-- Copyright Esperan Multimedia Products Limited 1995
--
-- Test bench for register bank to store the alarm 
-- time for the Alarm Clock project, 
-- forming part of the MasterClass VHDL Tutorial. 
--------------------------------------------------------------- 

Library IEEE;
use IEEE.Std_Logic_1164.all; 

entity T_ALREG is
end T_ALREG;

architecture TEST of T_ALREG is
   component ALREG
   port( NEW_ALARM_TIME        : in std_logic_vector(3 downto 0);
         LOAD_NEW_A            : in std_logic;
         CLK                   : in std_logic;
         RESET                 : in std_logic;
         ALARM_TIME            : out std_logic_vector(3 downto 0)
        );
   end component;

   signal NEW_ALARM_TIME        : std_logic_vector(3 downto 0);
   signal LOAD_NEW_A            : std_logic;
   signal ALARM_TIME            : std_logic_vector(3 downto 0);
   signal CLK                   : std_logic := '0';
   signal RESET                 : std_logic;
 
   constant PERIOD              : time := 10 ns;

begin

   ---------------------------------------------
   -- instantiate UUT
   ---------------------------------------------
   uut : ALREG port map(
         NEW_ALARM_TIME,
         LOAD_NEW_A,
         CLK,
         RESET,
         ALARM_TIME);

   ---------------------------------------------
   -- infinite clock generator 
   ---------------------------------------------
      CLK <= not CLK after PERIOD/2;
            
   --------------------------------------------------
   -- Stimulus   
   -------------------------------------------------
   STIMULUS : process
   begin
      -- pulse reset
      RESET <= '0';
      wait for 2 * PERIOD;
      RESET <= '1';                           -- ENTER VALUE
      wait for PERIOD;
      RESET <= '0';
      wait for PERIOD;
      LOAD_NEW_A<='1';
      NEW_ALARM_TIME<="0001";
      wait for PERIOD;
      LOAD_NEW_A<='0';
      NEW_ALARM_TIME<="0011";
      wait for PERIOD;
                                              -- ADD STIMULUS
     
   end process STIMULUS;

end TEST;

configuration CFG_T_ALREG of T_ALREG is
   for TEST
   end for;
end CFG_T_ALREG;
