----------------------------------------------------
-- Copyright Esperan 1992, 1994
-- Testbench for the display multiplexer,
-- forming part of the MasterClass VHDL Tutorial. 
----------------------------------------------------
 
Library IEEE;
use IEEE.Std_Logic_1164.all; 
use work.P_DISP1.all;

entity T_DDRV is
end T_DDRV;  

architecture TEST of T_DDRV is
   component DDRV
   port ( ALARM_TIME, CURRENT_TIME  : in std_logic_vector (3 downto 0);
          SHOW_A                    : in std_logic;
          SOUND_ALARM               : out std_logic;
          DISPLAY                   : out std_logic_vector (6 downto 0)
        );
   end component;

   signal ALARM_TIME, CURRENT_TIME  : std_logic_vector (3 downto 0);
   signal SHOW_A                    : std_logic;
   signal SOUND_ALARM               : std_logic;
   signal DISPLAY              : std_logic_vector (6 downto 0);

begin

   uut : DDRV port map (ALARM_TIME, 
                          CURRENT_TIME,
                          SHOW_A,
                          SOUND_ALARM,
                          DISPLAY);

---------------------------------------
-- Process to generate stimulus ...
---------------------------------------
   STIMULUS: process
   begin
      ALARM_TIME    <= "0000"; 
      CURRENT_TIME  <= "0000";
      SHOW_A       <= '0';
      wait for 10 ns;

      ALARM_TIME    <= "0001"; 
      CURRENT_TIME  <= "0000";
      SHOW_A       <= '1';
      wait for 10 ns;
      
      ALARM_TIME    <= "0010";
      wait for 10 ns;
      
      ALARM_TIME    <= "0011";
      wait for 10 ns;
      
      ALARM_TIME    <= "0100";
      wait for 10 ns;
      
      ALARM_TIME    <= "0101";
      wait for 10 ns;
      
      ALARM_TIME    <= "0110";
      wait for 10 ns;
      
      ALARM_TIME    <= "0111";
      wait for 10 ns;
      
      ALARM_TIME    <= "1000";
      wait for 10 ns;
      
      ALARM_TIME    <= "1001";
      wait for 10 ns;
      
      ALARM_TIME    <= "1111";
      wait for 10 ns;

      wait;
   end process STIMULUS;
   
   DISP1(DISPLAY);
 
end TEST;

---------------------------------------
-- configuration...
---------------------------------------

configuration CFG_T_DDRV of T_DDRV is
   for TEST
   end for;
end CFG_T_DDRV;

