---------------------------------------------------------------
-- Copyright Esperan Multimedia Products Limited 1995
--
-- Test bench for the array based display driver for the Alarm Clock 
-- project, forming part of the MasterClass VHDL Tutorial. 
--------------------------------------------------------------- 

Library IEEE;
use IEEE.Std_Logic_1164.all; 

use work.P_DISP4.all;

entity T_DDRV4 is
end T_DDRV4;  

architecture TEST of T_DDRV4 is

   component DDRV4
   port ( ALARM_TIME_LS_MIN, CURRENT_TIME_LS_MIN  : in std_logic_vector(3 downto 0);
          ALARM_TIME_MS_MIN, CURRENT_TIME_MS_MIN  : in std_logic_vector(3 downto 0);
          ALARM_TIME_LS_HR, CURRENT_TIME_LS_HR    : in std_logic_vector(3 downto 0);
          ALARM_TIME_MS_HR, CURRENT_TIME_MS_HR    : in std_logic_vector(3 downto 0);
          SHOW_A                    : in std_logic;
          SOUND_ALARM               : out std_logic;
          DISPLAY_LS_MIN            : out std_logic_vector(6 downto 0);
          DISPLAY_MS_MIN            : out std_logic_vector(6 downto 0);
          DISPLAY_LS_HR             : out std_logic_vector(6 downto 0);
          DISPLAY_MS_HR             : out std_logic_vector(6 downto 0)
          );				
   end component;

   signal ALARM_TIME_LS_MIN, CURRENT_TIME_LS_MIN  : std_logic_vector(3 downto 0);		
   signal ALARM_TIME_MS_MIN, CURRENT_TIME_MS_MIN  : std_logic_vector(3 downto 0);
   signal ALARM_TIME_LS_HR, CURRENT_TIME_LS_HR    : std_logic_vector(3 downto 0);
   signal ALARM_TIME_MS_HR, CURRENT_TIME_MS_HR    : std_logic_vector(3 downto 0);
   signal SHOW_A, SOUND_ALARM  : std_logic;
   signal DISPLAY_LS_MIN : std_logic_vector(6 downto 0);
   signal DISPLAY_MS_MIN : std_logic_vector(6 downto 0);
   signal DISPLAY_LS_HR : std_logic_vector(6 downto 0);
   signal DISPLAY_MS_HR : std_logic_vector(6 downto 0);
   
  

begin

   uut : DDRV4 port map ( ALARM_TIME_LS_MIN, CURRENT_TIME_LS_MIN,
                          ALARM_TIME_MS_MIN, CURRENT_TIME_MS_MIN,
                          ALARM_TIME_LS_HR, CURRENT_TIME_LS_HR,
                          ALARM_TIME_MS_HR, CURRENT_TIME_MS_HR,
                          SHOW_A, SOUND_ALARM,
                          DISPLAY_LS_MIN, DISPLAY_MS_MIN,
                          DISPLAY_LS_HR, DISPLAY_MS_HR
                        );

---------------------------------------
-- Process to generate stimulus ...
---------------------------------------

   STIMULUS: process
   begin

      ALARM_TIME_LS_MIN <= "0001";
      ALARM_TIME_MS_MIN <= "0010";
      ALARM_TIME_LS_HR <= "0000";
      ALARM_TIME_MS_HR <= "0101";
      CURRENT_TIME_LS_MIN <= "0111";
      CURRENT_TIME_MS_MIN <= "0011";
      CURRENT_TIME_LS_HR <= "0001";
      CURRENT_TIME_MS_HR <= "0010";
      SHOW_A <= '0';
      wait for 10 ns;
      SHOW_A <= '1';
      wait for 15 ns;
      CURRENT_TIME_LS_MIN <= "0001";
      CURRENT_TIME_MS_MIN <= "0010";
      CURRENT_TIME_LS_HR <= "0000";
      CURRENT_TIME_MS_HR <= "0101";
      wait for 15 ns;     

      wait;
   end process STIMULUS;
 
---------------------------------------
-- Seven Segment Display...
---------------------------------------
   DISP4(DISPLAY_MS_HR, DISPLAY_LS_HR, DISPLAY_MS_MIN, DISPLAY_LS_MIN);

end TEST;

---------------------------------------
-- configuration...
---------------------------------------

configuration CFG_T_DDRV4 of T_DDRV4 is
   for TEST
   end for;
end CFG_T_DDRV4;

