---------------------------------------------------------------
-- Copyright Esperan Multimedia Products Limited 1995
--
-- Test bench for the Timing Generator  for the 
-- Alarm Clock project,  forming part of the
-- MasterClass VHDL Tutorial. 
--------------------------------------------------------------- 
library IEEE;
                                             -- WHAT LIBRARY?
use IEEE.Std_Logic_1164.all; 

entity  T_TIMEG is
end  T_TIMEG;             -- SPECIFY THE ENTITY

architecture TEST of T_TIMEG is

   component TIMEGEN
   port( CLK             : in std_logic;
         RESET           : in std_logic;
         STOPWATCH       : in std_logic;
         ONE_SECOND      : out std_logic;
         ONE_MINUTE      : out std_logic);
   end component;

   signal ONE_SECOND, ONE_MINUTE       : std_logic;
   signal STOPWATCH, RESET        : std_logic;
   signal CLK        : std_logic:='0'; 

   constant PERIOD     : time := 10 ns;

begin

   ---------------------------------------------
   -- instantiate UUT
   ---------------------------------------------

   uut:  TIMEGEN port map( CLK,
         RESET,
         STOPWATCH,
         ONE_SECOND,
         ONE_MINUTE);

   ---------------------------------------------
   -- infinite clock generator 
   ---------------------------------------------

   CLK <=  not CLK after PERIOD/2;                         -- COMPLETE CLOCK GENERATOR

   --------------------------------------------------
   -- Stimulus: 
   -------------------------------------------------
   STIMULUS : process
   begin
     
     RESET<='1';
     STOPWATCH<='1';
     wait for PERIOD;
     RESET<='0';
     wait;

                                                   -- PUT YOUR STIMULUS HERE

   end process STIMULUS;

end TEST;

configuration CFG_T_TIMEG of T_TIMEG is
   for TEST
   end for;
end CFG_T_TIMEG;
