library IEEE;
use IEEE.Std_Logic_1164.all;
use IEEE.Std_Logic_arith.all;
--use IEEE.Numeric_Std.all;


entity TIMEGEN is
port (CLK             : in std_logic;
      RESET           : in std_logic;
      STOPWATCH       : in std_logic;
      ONE_SECOND      : out std_logic;
      ONE_MINUTE      : out std_logic);
end TIMEGEN;

architecture RTL of TIMEGEN is

signal I_ONE_SECOND: std_logic := '0';
signal ONE_MINUT_COUNT: unsigned(13 downto 0);

begin

  COUNTER_PROCESS:process(CLK,RESET)
    begin
      if RESET = '1' then
        ONE_MINUT_COUNT <= (others => '0');
      elsif CLK'event and CLK = '1' then 
        if ONE_MINUT_COUNT = 15359 then
          ONE_MINUT_COUNT <= (others => '0');
        else
          ONE_MINUT_COUNT <= ONE_MINUT_COUNT + 1;
        end if;
      end if;
  end process COUNTER_PROCESS;


  TICK: process (CLK, RESET)
  begin
    if RESET = '1' then
      I_ONE_SECOND <= '0';
      ONE_MINUTE <= '0';
    elsif CLK'event and CLK = '1' then
      if ONE_MINUT_COUNT(7 downto 0)=0 then
        I_ONE_SECOND <= '1';
      else I_ONE_SECOND <= '0';
      end if;  
      if ONE_MINUT_COUNT = 0 and STOPWATCH = '1' then 
        ONE_MINUTE <= '1';
      elsif STOPWATCH = '0' then
        ONE_MINUTE <= I_ONE_SECOND;
      else ONE_MINUTE <= '0';
      end if;
    end if;
  end process TICK;


  ONE_SECOND<=I_ONE_SECOND;

end RTL;
